#include <SoftwareSerial.h>

SoftwareSerial mySerial(14, 12); // RX - GPIO14 (D5), TX - GPIO12 (D6)

void setup() {
  Serial.begin(9600);  // стандартный UART для обмена данными с компьютером 
  mySerial.begin(9600); // программируемый UART для обмена данными с ESP32
 
}

void loop() {
   if (Serial.available() > 0) // если что-то приняли по стандартному UART 
   {
    char data = Serial.read();   // то побайтово записываем это в переменную
     mySerial.print(data);      // и передаём на ESP через программируемый UART
   }
    if ( mySerial.available() > 0) // если что-то приняли по программируемому UART 
   {
    char data =  mySerial.read();  // то побайтово записываем это в переменную
    Serial.print(data);            // и передаём на ESP через стандартный UART
   } 
   delay(10); 
}
      